from sortal import (transformSet, rule, primitiveSort, point2D, 
                    lineSegment2D, disjunctiveSort, affineTransform)
from sympy import pi, sin, cos
from api_create import create
from transform import transform

create = create()

def rule1(rotatingAngle):
    
    point = primitiveSort('point', point2D)
    lineSegSort = primitiveSort('lineSeg', lineSegment2D)
    
    v1 = vector2D (-1, -1)
    v2 = vector2D (-1, 1)
    v3 = vector2D (1, 1)
    v4 = vector2D (1, -1)
    
    p5 = vector2D (-1, -1)
    p6 = vector2D (-1, 1)
    p7 = vector2D (1, 1)
    p8 = vector2D (1, -1)
    
    v9 = vector2D (-1, -1)
    v10 = vector2D (-1, 1)
    v11 = vector2D (1, 1)
    v12 = vector2D (1, -1)
    
    #######################################################
    
    ls1 = lineSegment2D(lineSegSort, v1, v2) 
    ls2 = lineSegment2D(lineSegSort, v2, v3) 
    ls3 = lineSegment2D(lineSegSort, v3, v4) 
    ls4 = lineSegment2D(lineSegSort, v4, v1) 
    
    ls5 = lineSegment2D(lineSegSort, v5, v6)
    ls6 = lineSegment2D(lineSegSort, v6, v7)
    ls7 = lineSegment2D(lineSegSort, v7, v8)
    ls8 = lineSegment2D(lineSegSort, v8, v5)
    
    ls9 = lineSegment2D(lineSegSort, v9, v10)
    ls10 = lineSegment2D(lineSegSort, v10, v11)
    ls11 = lineSegment2D(lineSegSort, v11, v12)
    ls12 = lineSegment2D(lineSegSort, v12, v9)

    comp = [lineSegSort, point]
    disjunctive = disjunctiveSort('disjunctive', comp)
    
    formP1 = create.pointForm(pointSort, 1, 1)
    formP2 = create.pointForm(pointSort, 1, 1)
    
    formL1_set = [v1, v2, v3, v4]
    formL1 = create.polygon_form(lineSegSort, formL1_set)

    formL2_set = [v5, v6, v7, v8]
    formL2 = create.lineSeg_form(lineSegSort, formL2_set)

    ###############
    
    formL2 = transform(formL2, rotatingAngle) 
    formP2 = transform(formP2, rotatingAngle)
    formP2 = transform(formP2, rotatingAngle)
    formP1 = transform(formP1, rotatingAngle)
    
    ###############

    formL2.insert(ls9)
    formL2.insert(ls10)
    formL2.insert(ls11)
    formL2.insert(ls12)
    
    # LHS
    formsM1= [formL1, formP1]
    formM1 = create.metaForm(formsM1)
    
    # RHS
    formsM1= [formL2, formP2]
    formM1 = create.metaForm(formsM2)

    r = rule('Rule 1', 'Rotates square the angle specified by the argument rotatingAngle', formM1, formM2)
    return r