# -*- coding: utf-8 -*-
"""
Created on Fri Dec 23 12:09:56 2016

@author: akibdpt
"""
from __future__ import print_function
from __future__ import unicode_literals
from __future__ import division
from __future__ import absolute_import
from builtins import super
"""
from future import standard_library
standard_library.install_aliases()
"""
from .multiplyForm import multiplyForm
from .coForm import coForm
from ..transform.graphTransform import graphTransform3D

class areal(multiplyForm):
    type = 'form-areal'
    
    def __init__(self, sort, *args, **kwargs):
        super(areal, self).__init__(sort)
        
    """
    def __str__(self):
        s = self.sort.name+': {'
        printComma = False
        for i in self.elements:
            if printComma:
                s += ', '
            else:
                printComma = True
            s+= str(i)[1:-1]
        s += '}'
        return s
        
    """
    def __str__(self):
        s = '{'
        printComma = False
        for i in self.elements:
            if printComma:
                s += ', '
            else:
                printComma = True
            s+= str(i)[1:-1]
        s += '}'
        return s
        
    def printE(self, string = ''):
        print(string + '|' + self.sort.name+' areal:',len(self.elements),'elements')
        for ind in self.elements:
            ind.printE(string+'   ')
        return
        
    def printRhino(self, displacement = 0):
        #print(string + '|' + self.sort.name+':',len(self.elements),'elements')
        for cf in self.elements:
            cf.printRhino(displacement)
        return
        
    def accept(self, visitor, direction=-1):
        if visitor.visitEnter(self, direction) and not self.isEmpty():
            for element in self.elements:
                element.accept(visitor, direction)
        visitor.visitLeave(self)
        return
                
    def edit(self, editor):
        result = areal(self.sort)
        for element in self.elements:
            result.insert(element.edit(editor))
        if editor.current is None:
            transf = editor.retrieveTransform(graphTransform3D)
            if transf is not None:
                for i in transf.extra:
                    result.insert(i)
        return result
        
    """
    inserting an element into the form
    """
    def insert(self, plane):
        if plane.type == 'form-areal':
            for i in plane:
                self.insert(i)
        if plane.type == 'form-coForm':
            if not self.sort == plane.sort:
                raise ValueError('Inserting an object of sort '+plane.sort.name+' into a form of sort '+self.sort.name)
            self.maximal = False
            thisCoForm = self.first()
            index = 0
            while thisCoForm is not None:
                if thisCoForm.compareValue(plane) == 0:
                    for i in plane.elements:
                        thisCoForm.insert(i)
                    return
                elif thisCoForm.compareValue(plane) == 1:
                    self.add(index, plane)
                    return
                else: 
                    index = index+1
                    thisCoForm = self.get(index)      
            self.add(index, plane)
            return
        else:
            if not self.sort == plane.sort:
                raise ValueError('not of the same sort')
            self.maximal = False
            thisCoForm = self.first()
            index = 0
            while thisCoForm is not None:
                if thisCoForm.compareValuePlane(plane) == 0:
                    thisCoForm.insert(plane)
                    return
                elif thisCoForm.compareValuePlane(plane) == 1:
                    newcoForm = coForm(self.sort)
                    newcoForm.insert(plane)
                    self.add(index, newcoForm)
                    return
                else: 
                    index = index+1
                    thisCoForm = self.get(index)      
            newcoForm = coForm(self.sort)
            newcoForm.insert(plane)
            self.add(index, newcoForm)
                
    """
    maximalize the form:
    _remove Nil elements
    _reorder the elements in the form in ascending order
    """
    def maximalize(self):
        if self.maximal:
            return
    
        self.maximal = True
        
        if len(self.elements) == 0:
            return
        
        for coF in self.elements:
            coF.maximalize()     
        return
    
    """
    sum two forms (OR)
    e.g. formA: a, b, c
         formB:    b, c, d
        _formA.sum(formB)
      -->formA: a, b, c, d
    """
    def sum(self, other):
        if self is other:
            raise ValueError('Operation on two instances of the same form')
        if not self.sort.__eq__(other.sort):
            raise ValueError('Operation on two forms of different sorts '+str(self.sort)+'  and '+str(other.sort))
        
        self.maximalize()
        other.maximalize()
        
        thisCoForm = self.first()
        otherCoForm = other.first()
        index = 0
        indexOther = 0
        while thisCoForm is not None and otherCoForm is not None:
            if thisCoForm.compareValue(otherCoForm) == 0:
                #if has attribute, sum
                thisCoForm.sum(otherCoForm)
                index += 1
                indexOther += 1
                thisCoForm = self.get(index)                            
                otherCoForm = other.get(indexOther)
            elif thisCoForm.compareValue(otherCoForm) == 1:
                self.add(index, otherCoForm)                            
                indexOther += 1
                otherCoForm = other.get(indexOther)
            else:                          
                index += 1
                thisCoForm = self.get(index)                            
        while otherCoForm is not None:
            self.add(len(self.elements), otherCoForm)                            
            indexOther += 1
            otherCoForm = other.get(indexOther)
        return

    """
    difference of two forms
    e.g. formA: a, b, c
         formB:    b, c, d
        _formA.difference(formB)
      -->formA: a
    """
    def difference(self, other):
        if self is other:
            raise ValueError('Operation on two instances of the same form')
        if not self.sort.__eq__(other.sort):
            raise ValueError('Operation on two forms of different sorts '+str(self.sort)+'  and '+str(other.sort))
        
        self.maximalize()
        other.maximalize()
            
        thisIndex = 0
        otherIndex = 0
        thisCoForm = self.first()
        otherCoForm = other.first()

        while thisCoForm is not None and otherCoForm is not None:
            if thisCoForm.compareValue(otherCoForm) == 0:
                #if has attribute, calculate difference
                thisCoForm.difference(otherCoForm)
                if len(thisCoForm.elements) == 0:
                    self.pop(thisIndex)
                    thisCoForm = self.get(thisIndex)
                otherIndex += 1
                otherCoForm = other.get(otherIndex)
            elif thisCoForm.compareValue(otherCoForm) == 1:                            
                otherIndex += 1
                otherCoForm = other.get(otherIndex)
            else:                             
                thisIndex += 1
                thisCoForm = other.get(thisIndex)
        return

    """
    product of two forms (AND)
    e.g. formA: a, b, c
         formB:    b, c, d
        _formA.product(formB)
      -->formA:    b, c
    """
    def product(self, other):
        if self is other:
            raise ValueError('Operation on two instances of the same form')
        if not self.sort.__eq__(other.sort):
            raise ValueError('Operation on two forms of different sorts '+str(self.sort)+'  and '+str(other.sort))
            
        self.maximalize()
        other.maximalize()
                       
        thisIndex = 0
        otherIndex = 0
        thisCoForm = self.first()
        otherCoForm = other.first()
        while thisCoForm is not None and otherCoForm is not None:
            if thisCoForm.compareValue(otherCoForm) == 0:
                #if has attribute, product
                thisCoForm.product(otherCoForm)
                if len(thisCoForm.elements) == 0:
                    self.pop(thisIndex)
                    thisCoForm = self.get(thisIndex)
                otherIndex += 1
                otherCoForm = other.get(otherIndex)
            elif thisCoForm.compareValue(otherCoForm) == 1:                
                otherIndex += 1
                otherCoForm = other.get(otherIndex)
            else:                             
                self.pop(thisIndex)
                thisCoForm = self.get(thisIndex)
        while thisIndex < len(self.elements):   
            self.pop(thisIndex)
        return
        
    def symdifference(self, other):
        raise NotImplementedError

    def partition(self, other):
        raise NotImplementedError

    
        
    """
    check if this form is a part of other form
    """
    def partOf(self, other):
        if self is other:
            raise ValueError('Operation on two instances of the same form')
        if not self.sort == other.sort:
            if other.sort.contains(self.sort):
                for i in other:
                    if i.sort == self.sort or i.sort.contains(self.sort) and self.partOf(i):
                        return True
                return False
            raise ValueError('Operation on two forms of different sorts '+str(self.sort)+'  and '+str(other.sort))
            
        self.maximalize()
        other.maximalize()
                       
        thisIndex = 0
        otherIndex = 0
        thisCoForm = self.first()
        otherCoForm = other.first()
        while thisCoForm is not None and otherCoForm is not None:
            if thisCoForm.compareValue(otherCoForm) == 0:
                if not thisCoForm.partOf(otherCoForm):
                    return False
                thisIndex += 1
                otherIndex += 1
                thisCoForm = self.get(thisIndex)
                otherCoForm = other.get(otherIndex)
                
            elif thisCoForm.compareValue(otherCoForm) == 1:
                otherIndex += 1
                otherCoForm = other.get(otherIndex)
            else:                             
                return False
        return thisCoForm is None
        
    def convertFloat(self):
        result = self.sort.newForm()
        for i in self.elements:
            result.insert(i.convertFloat())
        result.maximal = self.maximal
        return result
        