# -*- coding: utf-8 -*-
"""
Created on Fri Aug  5 13:57:12 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from builtins import super
"""
from future import standard_library
standard_library.install_aliases()
"""
from ..element import element

"""
 * A form is a collection of {Individual}s (or forms) of the same
 * {Sort}. Forms belong to a few types, where each type specifies
 * a particular behavior for forms under common arithmetic operations such as
 * sum, difference, and product. Each characteristic {Individual} has
 * a behavior (Form class) assigned. 
 * 
 * Form types distinguish between singly- and multiply-associated sorts.
 * A {SinglyForm} specifies a form to contain only a single individual,
 * resulting in singly-associated sorts. An example is the {OrdinalForm}
 * specifying an ordinal behavior on numbers: any set of numbers is reduced to
 * the single maximum number, all other numbers in the original set are a part
 * of this maximum number.
 * 
 * A {MultiplyForm} allows a form to contain any number of individuals,
 * resulting in multiply-associated sorts. A {DiscreteForm} specifies a
 * discrete behavior corresponding to a set: any two individuals are either
 * identical or disjoint. An {IntervalForm} specifies a behavior of
 * intervals on a one-dimensional axis: if two intervals overlap, these are
 * combined into a single interval. A {RelationalForm} applies to
 * (bi-directional) relations. While its behavior is that of a discrete form,
 * relations are ultimately dependent on the individuals these relate and are
 * removed if any of their associate individuals are removed.
 * 
 * Finally, a {MetaForm} specifies a form consisting itself of forms from
 * different sorts. This corresponds to a {sortal.sort.DisjunctiveSort} as
 * a disjunctive combination of various sorts. Any individual belongs to
 * exactly one of the operand sorts.
 * 
 * The Form class extends on the Element class. It specifies the
 * interface as well as some common functionality for all subclasses. Each
 * subclass specifies a particular behavior for forms. A form is typically
 * represented as a list of elements, either individuals or forms. If a form
 * is assigned an attribute form to an individual, this individual is denoted
 * the associate to this form and is represented as such.
 * A form is denoted maximal if it is represented in its canonical form.
 * That is, the elements are ordered and no two elements in this form can be
 * combined into a single element of the same class. Forms are always
 * maximalized before these are compared or output.
"""
class form(element):

    formRegister = {}    
    
    def __init__(self, sort, *args, **kwargs):
        super(form, self).__init__(sort)
        self.name = None
        self.prev = None
        
    def printRhino(self, displacement = 0):
        return
        
    def register(self, name):
        if self.name is not None:
            form.formRegister.pop(self.name)
        if name in form.formRegister:
            self.prev = form.formRegister.pop(name)
        form.formRegister[name] = self
        self.name = name
        
    def isNil(self):
        return self.isEmpty()
    
    def isMaximal(self):
        raise NotImplementedError 
   
    def size(self):
        raise NotImplementedError 
    
    def first(self):
        raise NotImplementedError 
    
    def next(self, currentElement):
        raise NotImplementedError 
    
    def parse(self, reader, assoc=None):
        return
        
    def updateAssoc(self):
        for i in self:
            if i is not None:
                i.assoc = self
                i.updateAssoc()
        
    def checkPartOf(self, other, flagDesc = True):
        return self.partOf(other)
        
    def maximalize(self):
        raise NotImplementedError 

    def sum(self, other):
        raise NotImplementedError 
        
    def difference(self, other):
        raise NotImplementedError 
        
    def product(self, other):
        raise NotImplementedError 
        
    def partition(self, other):
        raise NotImplementedError 
        
    def partOf(self, other):
        raise NotImplementedError 
        
    def merge(self, other):
        raise NotImplementedError 
        
    def add(self, element):
        raise NotImplementedError 
        
    def remove(self, element):
        raise NotImplementedError 
    
    def edit(self, editor):
        raise NotImplementedError 
        
    def convertFloat(self):
        raise NotImplementedError 
        
