# -*- coding: utf-8 -*-
"""
Created on Tue May 30 10:21:14 2017

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from builtins import range
from builtins import super
from builtins import str

from .ruling import ruling

from random import randint

class ruleDisjunction(ruling):
    
    type = 'rule-disjunction'
    
    def __init__(self, rules, quantifier = '', matching = 'G', *args, **kwargs):
        super(ruleDisjunction, self).__init__()        
        self.rules = rules
        self.quantifier = quantifier
        self.matching = matching
        self.cycles = []
        self.lenS = []
    
    def apply(self, form, random = True, backtrace = False, s = [], *args, **kwargs):
        
        if not backtrace:
            self.lenS.append([len(s)])
            cycle = [[form.duplicate(),0]]
            self.trace = 0
            if self.matching == self.PROBABILISTIC and self.quantifier[1] is not None:
                self.tempMax = randint(self.quantifier[0], self.quantifier[1])
            else:
                self.tempMax = self.quantifier[1]
        elif self.matching == 'PO':
            l = self.lenS.pop()[0]
            while len(s) > l:
                s.pop()
            self.printS(s)
            return False
        else:
            cycle = self.cycles.pop(-1)
            if len(cycle) == 1:
                return False
            self.trace = cycle[-1][1]
            if self.trace < len(self.rules):
                form = cycle[-2][0]
            cycle.pop(-1)
                                        
        while self.quantifier[1] is None or len(cycle)-1 < self.tempMax:
            if self.trace == len(self.rules):
                cycle.pop(-1)
                self.trace = cycle[-1][1]+1
                
            if not backtrace:
                self.trace = 0
            else:
                form = cycle[-1][0].duplicate()
            
            while self.trace < len(self.rules):
                if self.rules[self.trace].type == 'rule':
                    if backtrace:
                        s.pop(-1)
                    self.printS(s)
                app = self.rules[self.trace].apply(form, backtrace = backtrace, s = s, random = random)
                backtrace = False
                if app is not False:
                    form = app
                    cycle.append([form.duplicate(), self.trace])
                    break
                else:
                    self.trace += 1                        
                    if self.trace == len(self.rules):
                        if len(cycle) > self.quantifier[0]:
                            self.cycles.append(cycle)
                            return cycle[-1][0]
                        if len(cycle) == 1:
                            return False
                            
                        backtrace = True
                        
                        self.trace = cycle[-1][1]
                        cycle.pop(-1)
                        
                        s.pop(-1)
                    form = cycle[-1][0].duplicate()    

            if self.matching == self.PROBABILISTIC and self.quantifier[1] is None:
                if randint(0,1) == 0:
                    break
        self.cycles.append(cycle)
        return form
        