# -*- coding: utf-8 -*-
"""
Created on Thu Nov 24 10:44:39 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from builtins import range
from builtins import str
from builtins import object

from ...io.parseReader import parseReader, ParsingError

class enumeration(object):
    """
    argList = '{identifier_1, identifier_2, identifier_3 ,..., identifier_n}
               [rank_1-1     rank_1-2     rank_1-3    ... rank_1-n
                rank_2-1     rank_2-2     rank_2-3    ... rank_2-n
                ...
                rank_n-1     rank_n-2     rank_n-3    ... rank_n-n]
    """
    def __init__(self, argList):
        if isinstance(argList, str) or isinstance(argList, unicode):
            reader = parseReader(argList)
            identifiers = []
            if reader.token() != '{':
                raise ParsingError(reader, 'Expected an enumeration of identifiers, separated with commas, and enclosed with curly brackets')
            if reader.newToken() != reader.IDENTIFIER:
                raise ParsingError(reader, 'Expected at least one identifier')
            identifiers.append(reader.value())
            while reader.newToken() == ',':
                if reader.newToken() != reader.IDENTIFIER:
                    raise ParsingError(reader, 'Expected identifier')
                identifiers.append(reader.value())
            if reader.token() != '}':
                raise ParsingError(reader, 'expected "}"')
                
            identifiers = sorted(identifiers)
            size = len(identifiers)

            if reader.newToken() != '[':
                raise ParsingError(reader, "Expected a list of " + (size * size) + " values taken from the previous list, separated with spaces, and enclosed with square brackets")
            
            ranking = [[None for i in range(size)] for j in range(size)]
            for i in range(size):
                for j in range(size):
                    if reader.newToken() != reader.IDENTIFIER:
                        raise ParsingError(reader, 'Expected identifier')
                    ranking[i][j] = identifiers.index(reader.value())
            self.values = identifiers
            self.rankings = ranking

        elif isinstance(argList, list):
            raise TypeError('newer way of reading enumeration has been implemented, enumeration argument should be string instead of list')
        else:
            raise TypeError('enumeration argument should be string')
        """
        elif isinstance(argList, list):
            current = 0
            if argList[0] == None:
                raise ValueError(argList[current], "Expected at least one identifier")
            identifiers = []
            while argList[current] != None:
                identifiers.append(argList[current])
                current += 1
                
            identifiers.sort()
            size = len(identifiers)
            
            ranking = []
            for i in range(size):
                ranking.append([])
                for j in range(size):
                    current += 1
                    ranking[i].append(identifiers.index(argList[current]))
        """
        
    def argValue(self):
        string = ''
        for i in range(len(self.values)-1):
            string+=self.values[i]+','
        string += self.values[-1]
        return string
        
    def ranking(self, first, second):
        if first <0 or second < 0 or first >= len(self.values) or second >= len(self.values):
            raise IndexError('enumeration index out of bounds')
        return self.rankings[first][second]